Blame view

install/install-3rdparty-linux-generic.sh 33.4 KB
1
#!/bin/bash
2
#
3
#  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil. 
4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37
#
#  This file is part of the TerraLib - a Framework for building GIS enabled applications.
#
#  TerraLib is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License,
#  or (at your option) any later version.
#
#  TerraLib is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with TerraLib. See COPYING. If not, write to
#  TerraLib Team at <terralib-team@terralib.org>.
#
#
#  Description: Install all required software for TerraLib on Linux Ubuntu 18.04.
#
#  Author: Gilberto Ribeiro de Queiroz
#          Paulo R. M. Oliveira
#
#
#  Example:
#  $ TERRALIB_DEPENDENCIES_DIR="/home/gribeiro/MyLibs" ./install-3rdparty-linux-generic.sh
#

echo "*****************************************************************"
echo "* TerraLib 3rd-party Libraries Installer for Generic Linux *"
echo "*****************************************************************"
echo ""
sleep 1s

38 39 40 41 42 43 44 45 46 47 48

if [ "$QT_QMAKE_EXECUTABLE" == "" ]; then
  QT_QMAKE_EXECUTABLE="qmake"
fi


if [ "$QT5_BASE_DIR" == "" ]; then
  echo "** Missing QT5_BASE_DIR variable **"
  exit 1
fi

49 50 51 52 53

if [ "$THREADS" == "" ]; then
  THREADS=4
fi

54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169
#
# Valid parameter val or abort script
#
function valid()
{
  if [ $1 -ne 0 ]; then
    echo $2
    echo ""
    exit $1
  fi
}


#
# CMake
#

# CMake installed
cmake_installed_version_first_dig=`cmake --version | grep version | awk 'NR ==1{print substr($3,1,1)}'`
cmake_installed_version_second_dig=`cmake --version | grep version | awk 'NR ==1{print substr($3,3,2)}'`

# Verify the first digit
if [[ "$cmake_installed_version_first_dig" == *"."* ]]; then
  cmake_installed_version_first_dig=`cmake --version | grep version | awk 'NR ==1{print substr($3,1,2)}'`
fi

# Verify the second digit
if [[ "$cmake_installed_version_second_dig" == *"."* ]]; then
  cmake_installed_version_second_dig=`cmake --version | grep version | awk 'NR ==1{print substr($3,3,1)}'`
fi

# Checking if the CMake is already installed
echo "Checking if the CMake is already installed..."
if [ "$cmake_installed_version_first_dig" -gt "3" -o "$cmake_installed_version_first_dig" -eq "3" -a "$cmake_installed_version_second_dig" -ge "11" ]; then
    echo "CMake already installed!"
elif [ "$cmake_installed_version_first_dig" -lt "3" ]; then
      echo "The version of CMake installed is not compatible with terralib!"
      echo "Minimum version required is 3.11*"
      echo ""
      exit
fi

# Checking if the CMake is in PATH
echo "Checking if the CMake is in PATH..."
if [ ! command -v cmake --version >/dev/null 2>&1 ]; then
    valid 1 "CMake already installed but not found in PATH!"
    echo ""
    exit
else
  echo "CMake already in PATH!"
fi

#
# Check for terralib-3rdparty-linux-ubuntu-18.04.tar.gz
#
if [ ! -f ./terralib-3rdparty-linux-ubuntu-18.04.tar.gz ]; then
  echo "Please, make sure to have terralib-3rdparty-linux-ubuntu-18.04.tar.gz in the current directory!"
  echo ""
  exit
fi

#
# Extract packages
#
echo "extracting packages..."
echo ""
sleep 1s

tar xzvf terralib-3rdparty-linux-ubuntu-18.04.tar.gz
valid $? "Error: could not extract 3rd party libraries (terralib-3rdparty-linux-ubuntu-18.04.tar.gz)"

echo "packages extracted!"
echo ""
sleep 1s


#
# Go to 3rd party libraries dir
#
cd terralib-3rdparty-linux-ubuntu-18.04
valid $? "Error: could not enter 3rd-party libraries dir (terralib-3rdparty-linux-ubuntu-18.04)"


#
# Check installation dir
#
if [ "$TERRALIB_DEPENDENCIES_DIR" == "" ]; then
  TERRALIB_DEPENDENCIES_DIR="/opt/terralib"
fi

export PATH="$PATH:$TERRALIB_DEPENDENCIES_DIR/bin"
export LD_LIBRARY_PATH="$PATH:$TERRALIB_DEPENDENCIES_DIR/lib"
export LDFLAGS=-Wl,-rpath=$TERRALIB_DEPENDENCIES_DIR/lib,--enable-new-dtags

echo "installing 3rd-party libraries to '$TERRALIB_DEPENDENCIES_DIR' ..."
echo ""
sleep 1s


#
# PCRE version 8.37
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libpcre.a" ]; then
  echo "installing PCRE..."
  echo ""
  sleep 1s

  tar xzvf pcre-8.37.tar.gz
  valid $? "Error: could not uncompress pcre-8.37.tar.gz!"

  cd pcre-8.37
  valid $? "Error: could not enter pcre-8.37 dir!"

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure PCRE!"

170
  make -j $THREADS
171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197
  valid $? "Error: could not make PCRE!"

  make install
  valid $? "Error: Could not install PCRE!"

  cd ..
fi


#
# SWIG version 3.0.12
# Site: http://www.swig.org
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/bin/swig" ]; then
  echo "installing SWIG..."
  echo ""
  sleep 1s

  tar xzvf swig-3.0.12.tar.gz
  valid $? "Error: could not uncompress swig-3.0.12.tar.gz!"

  cd swig-3.0.12
  valid $? "Error: could not enter swig-3.0.12 dir!"

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --with-pcre-prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure SWIG!"

198
  make -j $THREADS
199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224
  valid $? "Error: could not make SWIG!"

  make install
  valid $? "Error: Could not install SWIG!"

  cd ..
fi


#
# FreeXL version 1.0.1
# Site: https://www.gaia-gis.it/fossil/freexl/index
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libfreexl.so" ]; then
  echo "installing FreeXL..."
  sleep 1s

  tar xzvf freexl-1.0.1.tar.gz
  valid $? "Error: could not uncompress freexl-1.0.1.tar.gz!"

  cd freexl-1.0.1
  valid $? "Error: could not enter freexl-1.0.1 dir!"

  CPPFLAGS=-I$TERRALIB_DEPENDENCIES_DIR/include LDFLAGS=-L$TERRALIB_DEPENDENCIES_DIR/lib ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure FreeXL!"

225
  make -j $THREADS
226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251
  valid $? "Error: could not make FreeXL!"

  make install
  valid $? "Error: Could not install FreeXL!"

  cd ..
fi


#
# OOSP-UUID version 1.6.2
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libuuid.so" ]; then
  echo "installing OOSP-UUID..."
  echo ""
  sleep 1s

  tar xvf uuid-1.6.2.tar
  valid $? "Error: could not uncompress uuid-1.6.2.tar!"

  cd uuid-1.6.2
  valid $? "Error: could not enter uuid-1.6.2 dir!"

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --with-cxx
  valid $? "Error: could not configure OOSP-UUID!"

252
  make -j $THREADS
253 254 255 256 257 258 259 260 261 262 263 264
  valid $? "Error: could not make OOSP-UUID!"

  make install
 valid $? "Error: Could not install OOSP-UUID!"

  cd ..
fi


#
# BZIP2 version 1.0.6
#
265
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libbz2.so" ]; then
266 267 268 269
  echo "installing bzip2..."
  echo ""
  sleep 1s

270 271
  tar xzvf bzip2-1.0.6.tar.gz
  valid $? "Error: could not uncompress bzip2-1.0.6.tar.gz!"
272 273 274 275

  cd bzip2-1.0.6
  valid $? "Error: could not enter bzip2-1.0.6 dir!"

276 277 278 279 280 281
  make distclean

  make -f Makefile-libbz2_so 

  make clean

282
  make
283 284 285 286 287

  cp -a libbz2.so.1.0.6 $TERRALIB_DEPENDENCIES_DIR/lib

  ln -s $TERRALIB_DEPENDENCIES_DIR/lib/libbz2.so.1.0.6 $TERRALIB_DEPENDENCIES_DIR/lib/libbz2.so
  
288 289 290 291 292
  valid $? "Error: could not make BZIP2!"

  make install PREFIX=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: Could not install BZIP2!"

293 294
  rm -rf $TERRALIB_DEPENDENCIES_DIR/lib/libbz2.a

295 296 297
  cd ..
fi

298 299 300 301 302 303 304 305 306 307 308 309 310
#
# zlib version 1.2.11
# Site: https://www.zlib.net/
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libz.so" ]; then
  echo "installing zlib..."
  sleep 1s

  tar xzvf zlib-1.2.11.tar.gz
  valid $? "Error: could not uncompress zlib-1.2.11.tar.gz!"

  cd zlib-1.2.11
  valid $? "Error: could not enter zlib-1.2.11!"
311

312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327
  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure zlib!"

  make -j $THREADS
  valid $? "Error: could not make zlib!"

  make install
  valid $? "Error: Could not install zlib!"

  cd ..
fi


#
# OpenSSL version 1.1.1g
# Site: https://github.com/openssl/openssl/releases
328
#
329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libssl.so" ]; then
  echo "installing OpenSSL..."
  sleep 1s

  tar xzvf openssl-1.1.1g.tar.gz
  valid $? "Error: could not uncompress openssl-1.1.1g.tar.gz!"

  cd openssl-1.1.1g
  valid $? "Error: could not enter openssl-1.1.1g!"

  ./config --prefix=$TERRALIB_DEPENDENCIES_DIR shared -fPIC zlib-dynamic no-asm no-gost --with-zlib-include=$TERRALIB_DEPENDENCIES_DIR/include
  valid $? "Error: could not configure OpenSSL!"

  make -j $THREADS
  valid $? "Error: could not make OpenSSL!"

  CONFIG_OPTS="--strict-warnings zlib" make test
  valid $? "Error: could not test OpenSSL!"

  make install
  valid $? "Error: Could not install OpenSSL!"

  cd ..
fi


#
# SQLite version 3.32.3
357 358 359 360 361 362
# Site: https://www.sqlite.org
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libsqlite3.so" ]; then
  echo "installing SQLite..."
  sleep 1s

363 364
  tar xzvf sqlite-autoconf-3320300.tar.gz
  valid $? "Error: could not uncompress sqlite-autoconf-3320300.tar.gz!"
365

366 367
  cd sqlite-autoconf-3320300
  valid $? "Error: could not enter sqlite-autoconf-3320300!"
368

369
  CPPFLAGS="-DSQLITE_ENABLE_COLUMN_METADATA -DSQLITE_ENABLE_FTS4 -DSQLITE_ENABLE_RTREE -DSQLITE_SOUNDEX -DSQLITE_THREADSAFE=2" ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
370 371
  valid $? "Error: could not configure sqlite!"

372
  make -j $THREADS
373 374 375 376 377 378 379 380
  valid $? "Error: could not make sqlite"

  make install
  valid $? "Error: Could not install sqlite"

  cd ..
fi

381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433
#
# lib openjpeg version 2.3.1
# Site: https://www.openjpeg.org/
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libopenjp2.so" ]; then
  echo "installing openjpeg..."
  echo ""
  sleep 1s

  tar xzvf openjpeg-2.3.1.tar.gz
  valid $? "Error: could not uncompress openjpeg-2.3.1.tar.gz!"

  cd openjpeg-2.3.1
  valid $? "Error: could not enter openjpeg-2.3.1 dir!"

  cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" -DCMAKE_INSTALL_PREFIX=${TERRALIB_DEPENDENCIES_DIR}
  valid $? "Error: could not configure openjpeg!"

  make -j $THREADS
  valid $? "Error: could not make openjpeg!"

  make install
  valid $? "Error: Could not install openjpeg!"

  cd ..
fi

#
# Independent JPEG Group version v9a
# Site: http://www.ijg.org
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libjpeg.so" ]; then
  echo "installing Independent JPEG Group Library..."
  sleep 1s

  tar xzvf jpegsrc.v9a.tar.gz
  valid $? "Error: could not uncompress jpegsrc.v9a.tar.gz!"

  cd jpeg-9a
  valid $? "Error: could not enter jpeg-9a dir!"

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure JPEG!"

  make -j $THREADS
  valid $? "Error: could not make JPEG!"

  make install
  valid $? "Error: Could not install JPEG!"

  cd ..
fi

434 435

#
436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490
# TIFF version 4.1.0
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libtiff.so" ]; then
  echo "installing TIFF..."
  echo ""
  sleep 1s

  tar xzvf tiff-4.1.0.tar.gz
  valid $? "Error: could not uncompress tiff-4.1.0.tar.gz!"

  cd tiff-4.1.0
  valid $? "Error: could not enter tiff-4.1.0!"

  ./configure --enable-cxx --with-jpeg-include-dir=$TERRALIB_DEPENDENCIES_DIR/include --with-jpeg-lib-dir=$TERRALIB_DEPENDENCIES_DIR/lib --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure TIFF!"

  make -j $THREADS
  valid $? "Error: could not make TIFF!"

  make install
  valid $? "Error: Could not install TIFF!"

  cd ..
fi


#
# CURL version 7.71.1
# Site: http://curl.haxx.se/libcurl/
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libcurl.so" ]; then
  echo "installing CURL..."
  sleep 1s

  tar xzvf curl-7.71.1.tar.gz
  valid $? "Error: could not uncompress curl-7.71.1.tar.gz!"

  cd curl-7.71.1
  valid $? "Error: could not enter curl-7.71.1!"

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --with-ssl --with-zlib --libdir=$TERRALIB_DEPENDENCIES_DIR/lib
  valid $? "Error: could not configure CURL!"

  make -j $THREADS
  valid $? "Error: could not make CURL!"

  make install
  valid $? "Error: Could not install CURL!"

  cd ..
fi


#
# Proj version 7.1.0
491 492 493 494 495
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libproj.so" ]; then
  echo "installing Proj..."
  sleep 1s

496 497
  tar xzvf proj-7.1.0.tar.gz
  valid $? "Error: could not uncompress proj-7.1.0.tar.gz!"
498

499 500
  cd proj-7.1.0
  valid $? "Error: could not enter proj-7.1.0 dir!"
501 502 503 504
  
  mkdir cmake-build
  cd cmake-build

505
  cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=${TERRALIB_DEPENDENCIES_DIR} -DSQLITE3_INCLUDE_DIR=${TERRALIB_DEPENDENCIES_DIR}/include -DSQLITE3_LIBRARY=${TERRALIB_DEPENDENCIES_DIR}/lib/libsqlite3.so -DBUILD_TESTING=OFF -DBUILD_PROJ=ON -DBUILD_PROJINFO=ON -DENABLE_CURL=ON -DCURL_LIBRARY=${TERRALIB_DEPENDENCIES_DIR}/lib/libcurl.so -DCURL_INCLUDE_DIR=${TERRALIB_DEPENDENCIES_DIR}/include -DENABLE_TIFF=ON -DTIFF_LIBRARY_RELEASE=${TERRALIB_DEPENDENCIES_DIR}/lib/libtiff.so -DTIFF_INCLUDE_DIR=${TERRALIB_DEPENDENCIES_DIR}/include ..
506 507
  valid $? "Error: could not configure Proj!"

508
  make -j $THREADS
509 510 511 512 513 514 515 516 517 518 519 520 521
  valid $? "Error: could not make Proj!"
  
  ctest
  valid $? "Error: Proj tests fail!"  

  make install
  valid $? "Error: Could not install Proj!"

  cd ../..
fi


#
522
# GEOS version 3.8.1
523 524 525 526 527 528
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libgeos.so" ]; then
  echo "installing GEOS..."
  echo ""
  sleep 1s

529 530
  tar xjvf geos-3.8.1.tar.bz2
  valid $? "Error: could not uncompress geos-3.8.1.tar.bz2!"
531

532 533
  cd geos-3.8.1
  valid $? "Error: could not enter geos-3.8.1 dir!"
534 535 536 537

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure GEOS!"

538
  make -j $THREADS
539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564
  valid $? "Error: could not make GEOS!"

  make install
  valid $? "Error: Could not install GEOS!"

  cd ..
fi


#
# libPNG version 1.5.17
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libpng.so" ]; then
  echo "installing libPNG..."
  echo ""
  sleep 1s

  tar xzvf libpng-1.5.17.tar.gz
  valid $? "Error: could not uncompress libpng-1.5.17.tar.gz!"

  cd libpng-1.5.17
  valid $? "Error: could not enter libpng-1.5.17 dir!"

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure libPNG!"

565
  make -j $THREADS
566 567 568 569 570 571 572 573 574
  valid $? "Error: could not make libPNG!"

  make install
 valid $? "Error: Could not install libPNG!"

  cd ..
fi

#
575
# GeoTIFF version 1.6.0
576 577 578 579 580 581
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libgeotiff.so" ]; then
  echo "installing GeoTIFF..."
  echo ""
  sleep 1s

582 583
  tar xzvf libgeotiff-1.6.0.tar.gz
  valid $? "Error: could not uncompress libgeotiff-1.6.0.tar.gz!"
584

585 586
  cd libgeotiff-1.6.0
  valid $? "Error: could not enter libgeotiff-1.6.0!"
587 588 589 590

  ./configure --with-jpeg=$TERRALIB_DEPENDENCIES_DIR --with-zlib --with-libtiff=$TERRALIB_DEPENDENCIES_DIR --with-proj=$TERRALIB_DEPENDENCIES_DIR --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure GeoTIFF!"

591
  make -j $THREADS
592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617
  valid $? "Error: could not make GeoTIFF!"

  make install
  valid $? "Error: Could not install GeoTIFF!"

  cd ..
fi


#
# SZIP version 2.1
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libsz.so" ]; then
  echo "installing SZIP..."
  echo ""
  sleep 1s

  tar xzvf szip-2.1.tar.gz
  valid $? "Error: could not uncompress szip-2.1.tar.gz!"

  cd szip-2.1
  valid $? "Error: could not enter szip-2.1!"

  ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure SZIP!"

618
  make -j $THREADS
619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647
  valid $? "Error: could not make SZIP!"

  make install
  valid $? "Error: Could not install SZIP!"

  cd ..
fi


#
# ICU version 60.2
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libicuuc.so" ]; then
  echo "installing ICU..."
  echo ""
  sleep 1s

  tar xzvf icu4c-60_2-src.tgz
  valid $? "Error: could not uncompress icu4c-60_2-src.tgz!"

  cd icu/source
  valid $? "Error: could not enter icu/source!"

  chmod +x runConfigureICU configure install-sh
  valid $? "Error: could not set runConfigureICU to execute mode!"

  CPPFLAGS="-DU_USING_ICU_NAMESPACE=0 -DU_CHARSET_IS_UTF8=1 -DU_NO_DEFAULT_INCLUDE_UTF_HEADERS=1" ./runConfigureICU Linux/gcc --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not runConfigureICU!"

648
  make -j $THREADS
649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674
  valid $? "Error: could not make ICU!"

  make install
  valid $? "Error: Could not install ICU!"

  cd ../..
fi


#
# Xerces-c version 3.1.4
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libxerces-c.so" ]; then
  echo "installing Xerces..."
  echo ""
  sleep 1s

  tar xzvf xerces-c-3.1.4.tar.gz
  valid $? "Error: could not uncompress xerces-c-3.1.4.tar.gz!"

  cd xerces-c-3.1.4
  valid $? "Error: could not enter Xerces-c!"

  CPPFLAGS=-I$TERRALIB_DEPENDENCIES_DIR/include LDFLAGS=-L$TERRALIB_DEPENDENCIES_DIR/lib ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --enable-netaccessor-curl --disable-static --enable-msgloader-icu --with-icu=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure Xerces-c!"

675
  make -j $THREADS
676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701
  valid $? "Error: could not make Xerces-c!"

  make install
  valid $? "Error: Could not install Xerces-c!"

  cd ..
fi


#
# libxml2 version 2.9.1
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libxml2.so" ]; then
  echo "installing libxml2..."
  echo ""
  sleep 1s

  tar xzvf libxml2-2.9.1.tar.gz
  valid $? "Error: could not uncompress libxml2-2.9.1.tar.gz!"

  cd libxml2-2.9.1
  valid $? "Error: could not enter libxml2-2.9.1!"

  CPPFLAGS=-I$TERRALIB_DEPENDENCIES_DIR/include LDFLAGS=-L$TERRALIB_DEPENDENCIES_DIR/lib ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --with-icu --without-python
  valid $? "Error: could not configure libxml2!"

702
  make -j $THREADS
703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728
  valid $? "Error: could not make libxml2"

  make install
  valid $? "Error: Could not install libxml2"

  cd ..
fi


#
# libxslt version 1.1.28
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libxslt.so" ]; then
  echo "installing libxslt..."
  echo ""
  sleep 1s

  tar xzvf libxslt-1.1.28.tar.gz
  valid $? "Error: could not uncompress libxslt-1.1.28.tar.gz!"

  cd libxslt-1.1.28
  valid $? "Error: could not enter libxslt-1.1.28!"

  CPPFLAGS=-I$TERRALIB_DEPENDENCIES_DIR/include LDFLAGS=-L$TERRALIB_DEPENDENCIES_DIR/lib ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --with-libxml-prefix=$TERRALIB_DEPENDENCIES_DIR --without-debug
  valid $? "Error: could not configure libxslt!"

729
  make -j $THREADS
730 731 732 733 734 735 736 737 738 739
  valid $? "Error: could not make libxslt"

  make install
  valid $? "Error: Could not install libxslt"

  cd ..
fi


#
740
# Boost version 1.74.0
741 742 743 744 745 746
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libboost_thread.so" ]; then
  echo "installing boost..."
  echo ""
  sleep 1s

747 748
  tar xzvf boost_1_74_0.tar.gz
  valid $? "Error: could not uncompress boost_1_74_0.tar.gz!"
749

750 751
  cd boost_1_74_0
  valid $? "Error: could not enter boost_1_74_0!"
752 753 754 755 756 757 758 759 760 761 762 763

  ./bootstrap.sh
  valid $? "Error: could not configure Boost!"

  ./b2 runtime-link=shared link=shared variant=release threading=multi --prefix=$TERRALIB_DEPENDENCIES_DIR -sICU_PATH=$TERRALIB_DEPENDENCIES_DIR -sICONV_PATH=/usr -sBZIP2_INCLUDE=$TERRALIB_DEPENDENCIES_DIR/include -sBZIP2_LIBPATH=$TERRALIB_DEPENDENCIES_DIR/lib install
  valid $? "Error: could not make boost"

  cd ..
fi


#
764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816 817 818 819 820
# WebSocket 0.8.2
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/include/websocketpp/version.hpp" ]; then
  echo "installing WebSocket..."
  echo ""
  sleep 1s

  tar xzvf websocketpp-0.8.2.tar.gz
  valid $? "Error: could not uncompress websocketpp-0.8.2.tar.gz!"

  cd websocketpp-0.8.2
  valid $? "Error: could not enter websocketpp-0.8.2!"

  mkdir cmake-build
  cd cmake-build

  cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" -DCMAKE_INSTALL_PREFIX=${TERRALIB_DEPENDENCIES_DIR} -DBOOST_ROOT:PATH=${TERRALIB_DEPENDENCIES_DIR} -DENABLE_CPP11:BOOL=ON -DBUILD_TESTS:BOOL=OFF -DBUILD_EXAMPLES:BOOL=OFF ..
  valid $? "Error: could not configure WebSocket!"

  make install
  valid $? "Error: Could not install WebSocket"

  cd ../../
fi


#
# CppRestSDK 2.10.16
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libcpprest.so" ]; then
  echo "installing CppRestSDK..."
  echo ""
  sleep 1s

  tar xzvf cpprestsdk-2.10.16.tar.gz
  valid $? "Error: could not uncompress cpprestsdk-2.10.16.tar.gz!"

  cd cpprestsdk-2.10.16
  valid $? "Error: could not enter cpprestsdk-2.10.16!"

  mkdir cmake-build
  cd cmake-build

  cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" -DCMAKE_INSTALL_PREFIX=${TERRALIB_DEPENDENCIES_DIR} -DCMAKE_PREFIX_PATH=${TERRALIB_DEPENDENCIES_DIR}  -DBOOST_ROOT:PATH=${TERRALIB_DEPENDENCIES_DIR} -DBUILD_TESTS:BOOL=OFF -DBUILD_SAMPLES:BOOL=OFF ..
  valid $? "Error: could not configure CppRestSDK"

  make -j $THREADS
  valid $? "Error: could not make CppRestSDK"
  
  make install
  valid $? "Error: Could not install CppRestSDK"

  cd ../../
fi


#
821 822 823 824 825 826 827 828 829 830 831 832 833 834 835 836
# PostgreSQL version 9.6.12
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/pgsql/lib/libpq.so" ]; then
  echo "installing PostgreSQL..."
  echo ""
  sleep 1s

  tar xjvf postgresql-9.6.12.tar.bz2
  valid $? "Error: could not uncompress postgresql-9.6.12.tar.bz2!"

  cd postgresql-9.6.12
  valid $? "Error: could not enter postgresql-9.6.12!"

  CPPFLAGS="-I$TERRALIB_DEPENDENCIES_DIR/include -I$TERRALIB_DEPENDENCIES_DIR/include/libxml2" LDFLAGS="-lstdc++ -L$TERRALIB_DEPENDENCIES_DIR/lib" ./configure --with-libxml2 --with-libxslt --with-ossp-uuid --with-openssl --prefix=$TERRALIB_DEPENDENCIES_DIR/pgsql --with-includes=$TERRALIB_DEPENDENCIES_DIR/include --with-libraries=$TERRALIB_DEPENDENCIES_DIR/lib
  valid $? "Error: could not configure postgresql!"

837
  make -j $THREADS
838 839 840 841 842 843 844 845 846 847 848 849 850 851 852 853 854 855 856
  valid $? "Error: could not make postgresql"

  make install
  valid $? "Error: Could not install postgresql"

  cd contrib/uuid-ossp
  valid $? "Error: could not enter postgresql-9.6.12/contrib/uuid-ossp!"

  make
  valid $? "Error: could not make postgresql-9.6.12/contrib/uuid-ossp"

  make install
  valid $? "Error: Could not install postgresql-9.6.12/contrib/uuid-ossp"

  cd ../../..
fi


#
857
# HDF4 version 4.2.15
858 859 860 861 862 863
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libmfhdf.a" ]; then
  echo "installing HDF4..."
  echo ""
  sleep 1s

864 865
  tar xzvf hdf-4.2.15.tar.gz
  valid $? "Error: could not uncompress hdf-4.2.15.tar.gz!"
866

867 868
  cd hdf-4.2.15
  valid $? "Error: could not enter hdf-4.2.15!"
869 870 871 872

  CFLAGS=-fPIC ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --with-szlib=$TERRALIB_DEPENDENCIES_DIR --with-zlib --with-jpeg=$TERRALIB_DEPENDENCIES_DIR --enable-netcdf --disable-fortran
  valid $? "Error: could not configure hdf-4!"

873
  make -j $THREADS
874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897
  valid $? "Error: could not make hdf-4"

  make install
  valid $? "Error: Could not install hdf-4"

  cd ..
fi


#
# SpatiaLite version 4.3.0a
# Site: https://www.gaia-gis.it/fossil/libspatialite
# Obs.: In the future we should turn on libxml2 support.
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libspatialite.so" ]; then
  echo "installing SpatiaLite..."
  sleep 1s

  tar xzvf libspatialite-4.3.0a.tar.gz
  valid $? "Error: could not uncompress libspatialite-4.3.0a.tar.gz!"

  cd libspatialite-4.3.0a
  valid $? "Error: could not enter libspatialite-4.3.0a!"

Claudio Henrique Bogossian committed
898
  CPPFLAGS="-DACCEPT_USE_OF_DEPRECATED_PROJ_API_H -I$TERRALIB_DEPENDENCIES_DIR -I$TERRALIB_DEPENDENCIES_DIR/include"  LDFLAGS="-L$TERRALIB_DEPENDENCIES_DIR/lib" LIBXML2_CFLAGS="-I$TERRALIB_DEPENDENCIES_DIR/include/libxml2 -I$TERRALIB_DEPENDENCIES_DIR/include/libxml2/libxml" LIBXML2_LIBS="-L$TERRALIB_DEPENDENCIES_DIR/lib -lxml2" ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR --enable-geocallbacks --enable-examples=no --enable-libxml2  --with-geosconfig=$TERRALIB_DEPENDENCIES_DIR/bin/geos-config
899 900
  valid $? "Error: could not configure libspatialite!"

901
  make -j $THREADS
902 903 904 905 906 907 908 909 910 911
  valid $? "Error: could not make libspatialite"

  make install
  valid $? "Error: Could not install libspatialite"

  cd ..
fi


#
Mário Rocco Pettinati committed
912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927 928 929 930 931 932 933 934 935 936 937 938 939 940 941 942 943 944
# Libkml version 1.3.1
# Site: https://github.com/libkml/libkml
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libkmlbase.so" ]; then
  echo "installing libkml..."
  log_lib "libkml"

  sleep 1s

  tar xzvf libkml-1.3.0.tar.gz
  valid $? "Error: could not uncompress libkml-master.tar.gz!"

  cd libkml-1.3.0
  valid $? "Error: could not enter libkml-master!"
  
  mkdir cmake-build
  cd cmake-build

  cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE:STRING="Release" -DCMAKE_PREFIX_PATH:PATH=${TERRALIB_DEPENDENCIES_DIR} -DCMAKE_INSTALL_PREFIX:PATH=${TERRALIB_DEPENDENCIES_DIR} ..
  valid $? "Error: could not configure libkml!"

  make -j $THREADS
  valid $? "Error: could not make libkml"

  make install
  valid $? "Error: Could not install libkml"

  cd ../../

fi


#
945
# GDAL/OGR version 3.1.2
946 947 948 949 950 951
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libgdal.so" ]; then
  echo "installing GDAL/OGR..."
  echo ""
  sleep 1s

952 953
  tar xzvf gdal-3.1.2.tar.gz
  valid $? "Error: could not uncompress gdal-3.1.2.tar.gz!"
954

955 956
  cd gdal-3.1.2
  valid $? "Error: could not enter gdal-3.1.2!"
957

958
  PKG_CONFIG_PATH="$TERRALIB_DEPENDENCIES_DIR/pgsql/lib/pkgconfig/:$TERRALIB_DEPENDENCIES_DIR/lib/pkgconfig/" CPPFLAGS="-I$TERRALIB_DEPENDENCIES_DIR/include -I$TERRALIB_DEPENDENCIES_DIR/include/libxml2" LDFLAGS="-L$TERRALIB_DEPENDENCIES_DIR/lib -Wl,-rpath,$TERRALIB_DEPENDENCIES_DIR/pgsql/lib" ./configure --with-pg=yes --with-png=$TERRALIB_DEPENDENCIES_DIR --with-libtiff=$TERRALIB_DEPENDENCIES_DIR --with-geotiff=$TERRALIB_DEPENDENCIES_DIR --with-jpeg=$TERRALIB_DEPENDENCIES_DIR  --with-gif --with-ecw=yes --with-xerces=$TERRALIB_DEPENDENCIES_DIR --with-expat=yes --with-openjpeg-2.0=$TERRALIB_DEPENDENCIES_DIR --with-curl=$TERRALIB_DEPENDENCIES_DIR/bin/curl-config --with-sqlite3=$TERRALIB_DEPENDENCIES_DIR --with-geos=$TERRALIB_DEPENDENCIES_DIR/bin/geos-config --with-threads --with-spatialite=$TERRALIB_DEPENDENCIES_DIR --with-freexl=$TERRALIB_DEPENDENCIES_DIR --without-python --prefix=$TERRALIB_DEPENDENCIES_DIR --with-xml2=yes  --with-libkml --with-hdf4=$TERRALIB_DEPENDENCIES_DIR --without-netcdfd
959 960
  valid $? "Error: could not configure gdal!"

961
  make -j $THREADS -s
962 963 964 965 966 967 968 969 970 971 972 973 974 975 976 977 978 979 980 981 982 983 984 985 986 987
  valid $? "Error: could not make gdal"

  make install
  valid $? "Error: Could not install gdal"

  cd ..
fi


#
# CppUnit version 1.12.1
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libcppunit.so" ]; then
  echo "installing CppUnit.."
  echo ""
  sleep 1s

  tar xzvf cppunit-1.12.1.tar.gz
  valid $? "Error: could not uncompress cppunit-1.12.1.tar.gz!"

  cd cppunit-1.12.1
  valid $? "Error: could not enter cppunit-1.12.1!"

  LDFLAGS="-ldl" ./configure --prefix=$TERRALIB_DEPENDENCIES_DIR
  valid $? "Error: could not configure cppunit!"

988
  make -j $THREADS
989 990 991 992 993 994 995 996 997 998 999 1000 1001 1002 1003 1004 1005 1006 1007 1008 1009 1010 1011
  valid $? "Error: could not make cppunit"

  make install
  valid $? "Error: Could not install cppunit"

  cd ..
fi


#
# Qt Property Browser
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libqt_property_browser.so" ]; then
  echo "installing Qt Property Browser..."
  echo ""
  sleep 1s

  tar xzvf qtpropertybrowser.tar.gz
  valid $? "Error: could not uncompress qtpropertybrowser.tar.gz!"

  cd qtpropertybrowser
  valid $? "Error: could not change dir to qtpropertybrowser!"

1012
  $QT_QMAKE_EXECUTABLE "TERRALIB_DIR=$TERRALIB_DEPENDENCIES_DIR"
1013 1014
  valid $? "Error: could not run qmake for qt-property-browser!"

1015
  make -j $THREADS
1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026 1027 1028 1029 1030 1031 1032 1033 1034 1035 1036 1037 1038
  valid $? "Error: could not make qt-property-browser!"

  make install
  valid $? "Error: Could not install qt-property-browser!"

  cd ..
fi


#
# QScintilla version 2.10
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libqscintilla2.so" ]; then
  echo "installing QScintilla..."
  echo ""
  sleep 1s

  tar xzvf QScintilla_gpl-2.10.tar.gz
  valid $? "Error: could not uncompress QScintilla_gpl-2.10.tar.gz!"

  cd QScintilla_gpl-2.10/Qt4Qt5
  valid $? "Error: could not change dir to QScintilla_gpl-2.10/Qt4Qt5!"

1039
  $QT_QMAKE_EXECUTABLE "TERRALIB_DIR=$TERRALIB_DEPENDENCIES_DIR"
1040 1041
  valid $? "Error: could not prepare QScintilla build with qmake!"

1042
  make -j $THREADS
1043 1044 1045 1046 1047 1048 1049 1050 1051 1052 1053 1054 1055 1056 1057 1058 1059 1060 1061 1062 1063 1064 1065 1066 1067 1068 1069 1070 1071
  valid $? "Error: could not make QScintilla!"

  make install
  valid $? "Error: Could not install QScintilla!"

  cd ../..
fi


#
# Lua version 5.3.4
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/liblua.so" ]; then
  echo "installing Lua..."
  echo ""
  sleep 1s

  tar xzvf lua-5.3.4.tar.gz
  valid $? "Error: could not uncompress lua-5.3.4.tar.gz!"

  cd lua-5.3.4
  valid $? "Error: could not change dir to lua-5.3.4!"

  mkdir cmake-build
  cd cmake-build

  cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" -DCMAKE_INSTALL_PREFIX=${TERRALIB_DEPENDENCIES_DIR} -DINSTALL_INC=${TERRALIB_DEPENDENCIES_DIR}/include/lua ..
  valid $? "Error: could not configure Lua!"

1072
  make -j $THREADS
1073 1074 1075 1076 1077 1078 1079 1080 1081 1082 1083 1084 1085 1086 1087 1088 1089 1090 1091 1092 1093 1094 1095 1096 1097 1098 1099 1100
  valid $? "Error: could not make Lua!"

  make install
  valid $? "Error: could not install Lua!"

  cd ../..
fi


#
# QtLua version 2.0
#

if [ "$TE_USE_QT" != "qt4" ]; then
  if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libqtlua.so" ]; then
    echo "installing QtLua..."
    echo ""
    sleep 1s

    tar xzvf libqtlua-2.0.tar.gz
    valid $? "Error: could not uncompress libqtlua-2.0.tar.gz!"

    cd libqtlua-2.0
    valid $? "Error: could not change dir to libqtlua-2.0!"

    mkdir cmake-build
    cd cmake-build

1101
    cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" -DCMAKE_INSTALL_PREFIX=${TERRALIB_DEPENDENCIES_DIR} -DCMAKE_PREFIX_PATH=${TERRALIB_DEPENDENCIES_DIR}/lib -DQt5_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5 -DQt5Core_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Core -DQt5Gui_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Gui -DQt5LinguistTools_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5LinguistTools -DQt5PrintSupport_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5PrintSupport -DQt5Sql_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Sql Qt5Svg_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Svg -DQt5Widgets_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Widgets -DQt5_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5 -DLUA_INCLUDE_DIR=${TERRALIB_DEPENDENCIES_DIR}/include/lua .. 
1102 1103
    valid $? "Error: could not configure QtLua!"

1104
    make -j $THREADS
1105 1106 1107 1108 1109 1110 1111 1112 1113 1114 1115 1116 1117 1118 1119 1120 1121 1122 1123 1124 1125 1126 1127 1128 1129 1130 1131 1132 1133 1134 1135
    valid $? "Error: could not make QtLua!"

    make install
    valid $? "Error: could not install QtLua!"

    cd ..

    cp -r src/internal $TERRALIB_DEPENDENCIES_DIR/include/QtLua/
    valid $? "Error: could not copy QtLua internal folder!"

    cd ..
  fi


  #
  # QtLuaExtras
  #
  if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/qtluae.so" ]; then
    echo "installing QtLuaExtras..."
    echo ""
    sleep 1s

    tar xzvf qtluae.tar.gz
    valid $? "Error: could not uncompress qtluae.tar.gz!"

    cd qtluae
    valid $? "Error: could not change dir to qtluae!"

    mkdir cmake-build
    cd cmake-build

1136
    cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" -DCMAKE_INSTALL_PREFIX=${TERRALIB_DEPENDENCIES_DIR} -DQt5_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5 -DQt5Core_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Core -DQt5Gui_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Gui -DQt5LinguistTools_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5LinguistTools -DQt5PrintSupport_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5PrintSupport -DQt5Sql_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Sql Qt5Svg_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Svg -DQt5Widgets_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5Widgets -DQt5_DIR:PATH=$QT5_BASE_DIR/lib/cmake/Qt5 -DLUA_LIBRARY=${TERRALIB_DEPENDENCIES_DIR}/lib/liblua.so -DLUA_INCLUDE_DIR=${TERRALIB_DEPENDENCIES_DIR}/include/lua -DQTLUA_INCLUDE_DIR=${TERRALIB_DEPENDENCIES_DIR}/include -DQTLUA_LIBRARY=${TERRALIB_DEPENDENCIES_DIR}/lib/libqtlua.so ../build/cmake
1137

1138
    make -j $THREADS
1139 1140 1141 1142 1143 1144 1145 1146 1147 1148 1149 1150 1151 1152 1153 1154 1155 1156 1157 1158 1159 1160 1161 1162 1163 1164 1165
    valid $? "Error: could not make QtLuaExtras!"

    make install
    valid $? "Error: could not install QtLuaExtras!"

    cp -a ${TERRALIB_DEPENDENCIES_DIR}/lib/libqtluae.so ${TERRALIB_DEPENDENCIES_DIR}/lib/qtluae.so
    valid $? "Error: could not copy QtLuaExtras internal folder!"

    cd ../..
  fi
fi # endif [ "$TE_USE_QT" != "qt4" ]; then


#
# Qwt version 6.1.2
# Site: http://qwt.sourceforge.net
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libqwt.so" ]; then
  echo "installing Qwt..."
  sleep 1s

  tar xjvf qwt-6.1.2.tar.bz2
  valid $? "Error: could not uncompress qwt-6.1.2.tar.bz2!"

  cd qwt-6.1.2
  valid $? "Error: could not change dir to qwt-6.1.2!"

1166
  $QT_QMAKE_EXECUTABLE qwt.pro "QWT_INSTALL_PREFIX_TARGET=$TERRALIB_DEPENDENCIES_DIR"
1167 1168
  valid $? "Error: could not configure Qwt!"

1169
  make -j $THREADS
1170 1171 1172 1173 1174 1175 1176 1177 1178 1179 1180 1181 1182 1183 1184 1185 1186 1187 1188 1189 1190 1191 1192 1193 1194 1195 1196 1197 1198 1199 1200 1201 1202 1203 1204 1205 1206 1207 1208 1209 1210 1211 1212 1213 1214 1215 1216 1217 1218 1219 1220 1221 1222 1223 1224 1225 1226 1227 1228 1229 1230 1231 1232 1233 1234 1235 1236 1237 1238 1239 1240 1241 1242 1243
  valid $? "Error: could not make Qwt!"

  make install
  valid $? "Error: could not copy Qwt internal folder!"

  cd ..
fi


#
# GTest and GMock
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libgmock.a" ]; then
  echo "installing GTest and GMock..."
  sleep 1s

  unzip googletest-master.zip
  valid $? "Error: could not uncompress googletestmaster.zip!"

  cd googletest-master/googletest
  valid $? "Error: could not enter googletestmaster!"

  cmake .
  valid $? "Error: could not configure googletest!"

  make
  valid $? "Error: could not make googletest!"

  cp libgtest.a $TERRALIB_DEPENDENCIES_DIR/lib/
  valid $? "Error: could not copy libgtest.a!"

  cp libgtest_main.a $TERRALIB_DEPENDENCIES_DIR/lib/
  valid $? "Error: could not copy libgtest_main.a!"

  cp -r include/gtest/ $TERRALIB_DEPENDENCIES_DIR/include/
  valid $? "Error: could not copy include dir!"

  cd ../googlemock

  cmake .
  valid $? "Error: could not configure googlemock!"

  make
  valid $? "Error: could not make googlemock!"

  cp libgmock.a $TERRALIB_DEPENDENCIES_DIR/lib/
  valid $? "Error: could not copy libgmock.a!"

  cp libgmock_main.a $TERRALIB_DEPENDENCIES_DIR/lib/
  valid $? "Error: could not copy libgmock_main.a!"

  cp -r include/gmock $TERRALIB_DEPENDENCIES_DIR/include/
  valid $? "Error: could not copy include dir!"

  cd ../..
fi

#
# Wtss Cxx version 0.4.0
#
if [ ! -f "$TERRALIB_DEPENDENCIES_DIR/lib/libwtss_cxx_client.so" ]; then
  echo "installing Cxx"
  echo ""
  sleep 1s

  tar xzvf wtss-cxx.tar.gz
  valid $? "Error: could not uncompress wtss-cxx.tar.gz!"

  cd wtss-cxx
  valid $? "Error: could not change dir to wtss-cxx!"

  cmake -G "Unix Makefiles" -DCMAKE_PREFIX_PATH:PATH=${TERRALIB_DEPENDENCIES_DIR} -DCMAKE_INSTALL_PREFIX:PATH=${TERRALIB_DEPENDENCIES_DIR} -DCMAKE_INSTALL_RPATH:PATH=${TERRALIB_DEPENDENCIES_DIR} -DCMAKE_SKIP_BUILD_RPATH:BOOL="OFF" -DCMAKE_BUILD_WITH_INSTALL_RPATH:BOOL="OFF" -DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL="ON" -DCMAKE_BUILD_TYPE:STRING="Release" build/cmake
  valid $? "Error: could not configure wtss-cxx!"

1244
  make -j $THREADS
1245 1246 1247 1248 1249 1250 1251 1252 1253 1254 1255 1256 1257 1258 1259 1260
  valid $? "Error: could not make wtss-cxx!"

  make install
  valid $? "Error: could not install wtss-cxx!"

  cd ..
fi

#
# Finished!
#
echo "*****************************************************************"
echo "* TerraLib 3rd-party Libraries Installer for Linux Ubuntu 18.04 *"
echo "*****************************************************************"
echo ""
echo "finished successfully!"